import requests
import time
import datetime
import pymysql
import random

cookies = {
    "sessionid": '6',
}

s = requests.session()

s.keep_alive = False

requests.adapters.DEFAULT_RETRIES = 5


auto_follow_url = "http://earth.igengmei.com/api/v1/follow"

login_url = "http://earth.igengmei.com/api/account/login_pwd"


def index_first():
    r1=requests.get(login_url)
    return r1.cookies.get_dict()

def login(cookies,user,pwd):
    post_dict={
        'account_type':user,
        'pwd':pwd
    }
    response = requests.post(
        url=login_url,
        data=post_dict,
        cookies=cookies
    )
    print(response.text, 'url')


def follow(cookies_get, id):
    post_dict = {
        'type': 1,
        'id': id
    }
    response = requests.post(url=auto_follow_url,
                             cookies=cookies_get,
                             data=post_dict)

    print(response.text, 'url')

    content = response.text

    # list= []
    # for i in content[0].strip('{}').split(','):
    #  for j in i.split(':'):
    #     list.append(j)
    # if list[1]==' 1':
    # print('click error ')


def time_conv(numtime):
    now = datetime.datetime.now()
    yes_time = now - datetime.timedelta(days=numtime)
    yes_time_str = yes_time.strftime('%Y-%m-%d')
    print(now)
    return yes_time_str


def get_data(numtime):
    db = pymysql.connect(host="rm-2ze5k2we69904787l.mysql.rds.aliyuncs.com", user='work', passwd='Gengmei123',
                         db="alpha", port=3306)
    cursor = db.cursor()
    print("---------")

    cursor.execute("SELECT id FROM topic WHERE create_time LIKE '%%%%%s%%%%'" % numtime)
    data = cursor.fetchall()

    # cursor.execute("SELECT id FROM topic WHERE create_time LIKE '%%%%%s%%%%'" % numtime)
    # data = cursor.fetchall()

    user_id = list(data)



    print("Database version : %s " % user_id)
    db.close()
    return user_id


def get_star_data(numtime):

    db = pymysql.connect(host="rm-2ze5k2we69904787l.mysql.rds.aliyuncs.com", user='work', passwd='Gengmei123',
                         db="alpha", port=3306)
    cursor = db.cursor()

    print("---------")

    cursor.execute(
        "SELECT id FROM topic WHERE content_level =4 or content_level =5 and create_time LIKE '%%%%%s%%%%'" % numtime)

    data = cursor.fetchall()

    user_id = list(data)

    print("Database version : %s " % user_id)

    db.close()

    return user_id


def get_commnet_id(numtime):

    db = pymysql.connect(host="rm-2ze5k2we69904787l.mysql.rds.aliyuncs.com", user='work', passwd='Gengmei123',
                         db="alpha", port=3306)
    cursor = db.cursor()

    print("---------")

    cursor.execute(
        "SELECT  user_id FROM reply WHERE  create_time LIKE '%%%%%s%%%%'" % numtime)

    data_comment = cursor.fetchall()

    cursor.execute(
        "SELECT  replied_id  FROM reply WHERE  create_time LIKE '%%%%%s%%%%'" % numtime)

    data_reply = cursor.fetchall()

    cursor.execute(
        "SELECT  user_id FROM group_follow  WHERE  create_time LIKE '%%%%%s%%%%'" % numtime)

    data_group_follow = cursor.fetchall()

    cursor.execute(
        "select  user_id from account_user  WHERE  create_time LIKE '%%%%%s%%%%'" % numtime)

    data_new_user = cursor.fetchall()

    cursor.execute(
        "select  user_id,follow_id from user_follow  WHERE  create_time LIKE '%%%%%s%%%%'" % numtime)

    data_majia_follow = cursor.fetchall()


    data_id = list(data_comment)
    data1_id=list(data_reply)
    data2_id=list(data_group_follow)
    data3_id=list(data_new_user)
    data4_id=list(data_majia_follow)

    majia_list=[]

    user_id = []

    for i in majia_list:
        for j in data4_id:
            if i == j[0]:
                user_id.append(j[1])
    for i in data_id:
        user_id.append(i)
    for i in data1_id:
        user_id.append(i)
    for i in data2_id:
        user_id.append(i)
    for i in data3_id:
        user_id.append(i)

    print("Database version : %s " % user_id)

    db.close()

    return user_id


if __name__ == "__main__":

    sleep_time=[]

    flag = 0
    for i in range(0,11):

        sleep_time.append(random.randint(1800,3500))

    for i in sleep_time:

        time.sleep(i)

        if flag == 0:

            numtime=time_conv(1)

            user_id = get_star_data(numtime)

            # 1-5  fensi

            for j in user_id:

                id= int(j[0])

                # cookies = index_first()

                # login(cookies,user=cookies,pwd='')

                follow(cookies, id)


        time_list = [1, 2, 7, 30]

        numtime = time_conv(time_list[flag])

        user_id = get_data(numtime)

        for j in user_id:

            id = int(j[0])

            # cookies = index_first()

            # login(cookies,user=cookies,pwd='')

            follow(cookies, id)

        flag += 1


        user_id=get_commnet_id(1)



# 注册
#     1. 每日一次轮询，给每个昨日新注册用户加粉：[0-1]个粉丝
# 启动***********
#     1. 每日一次轮询，昨日启动 即触发加粉策略：[0-1]个粉丝
# 评论
#     1. 昨日有收到评论的用户：[0-1]个粉丝
#
#     2. 昨日有发出评论的用户：[0-1]个粉丝
# 加组
#     1. 昨日加组的用户：[0-1]个粉丝
# 关注
#     如果马甲被关注，即刻 反向 关注用户	5min后



# 发帖
#     1. 每日一次轮询，昨日发帖的用户：[1-2]个粉丝
#
#     2. 每日一次轮询，2日前发帖的用户：[1-2]个粉丝
#
#     3. 每日一次轮询，7日前发帖的用户：[1]个粉丝
#
#     4. 每日一次轮询，30日前发帖的用户：[1-2]个粉丝
# 流失
#     每周3 执行一次轮询，超过7天没有访问的用户：[1-2]个粉丝
#
#     每周3 执行一次轮询，超过30天没有访问的用户：[1-2]个粉丝



# 发帖
#     5. 每日一次轮询，昨日有帖子被选为4、5星的用户：[1-5]个粉丝