import requests
import time
import datetime
import pymysql
import random

cookies = {
    "sessionid": '1',
}


auto_click_url = "http://earth.igengmei.com/api/v1/pick/do_pick"

login_url = "http://earth.igengmei.com/api/account/login_pwd"


def index_first():

    r1=requests.get(login_url)

    return r1.cookies.get_dict()


def login(cookies,user,pwd):

    post_dict={
        'account_type':user,
        'pwd':pwd
    }
    response=requests.post(
        url=login_url,
        data=post_dict,
        cookies=cookies
    )
    print(response.text,'url')


def pick(cookies_get,id,content):
    post_dict={
        'pick_user_id':id,
        'is_pick':1,
        'pick_type':0
    }
    response=requests.get(url=auto_click_url,
                      cookies=cookies_get,
                      data=post_dict)

    print(response.text, 'url')


def time_conv(numtime):

    now = datetime.datetime.now()
    yes_time  = now -datetime.timedelta(days=numtime)
    yes_time_str=yes_time.strftime('%Y-%m-%d')
    print(now)
    return yes_time_str

def get_data(numtime):
    db = pymysql.connect(host="rm-2ze5k2we69904787l.mysql.rds.aliyuncs.com", user='work', passwd='Gengmei123', db="alpha", port=3306)
    cursor = db.cursor()
    print("---------")
    cursor.execute("SELECT id FROM topic WHERE create_time LIKE '%%%%%s%%%%'" %numtime)
    data = cursor.fetchall()
    user_id = list(data)
    print("Database version : %s " % user_id)
    db.close()

    return user_id

def get_star_data(numtime):

    db = pymysql.connect(host="rm-2ze5k2we69904787l.mysql.rds.aliyuncs.com", user='work', passwd='Gengmei123',
                         db="alpha", port=3306)
    cursor = db.cursor()

    print("---------")

    cursor.execute(
        "SELECT id FROM topic WHERE content_level =4 or content_level =5 and create_time LIKE '%%%%%s%%%%'" % numtime)

    data = cursor.fetchall()
    user_id = list(data)

    print("Database version : %s " % user_id)

    db.close()

    return user_id


def get_all(numtime):
    db = pymysql.connect(host="rm-2ze5k2we69904787l.mysql.rds.aliyuncs.com", user='work', passwd='Gengmei123',
                         db="alpha", port=3306)
    cursor = db.cursor()

    print("---------")

    ## 每日一次轮询，给每个昨日新注册用户pick：[0-1]个粉丝pick了你
    cursor.execute(
        "select  user_id from account_user  WHERE  create_time LIKE '%%%%%s%%%%'" % numtime)

    data_new_user = cursor.fetchall()

    data3_id = list(data_new_user)

    print("Database version : %s " % user_id)

    db.close()

    return user_id



if __name__ == "__main__":

    sleep_time=[]

    for i in range(1,7):

        sleep_time.append(random.randint(1800,3500))

    for i in sleep_time:

        time.sleep(i)

        time_list=[1,3,5,7]

        for i in time_list:

            numtime=time_conv(i)

            user_id=get_data(numtime)

            for j in user_id:

                id=int(j[0])

                cookies=index_first()

                login(cookies,user=cookies,pwd='')

                comment="太好看了！"

                id = 1

                pick(cookies,id,comment)


# 启动
    # 每日一次轮询，昨日启动 即触发pick策略：[0-1]个粉丝pick了你

# 发帖
    # 1. 每日一次轮询，昨日发帖的用户：[1-2]个粉丝pick了你
    #
    # 2. 每日一次轮询，3日前发帖的用户：[1-2]个粉丝pick了你
    #
    # 3. 每日一次轮询，昨日有帖子被选为4、5星的用户：[1-5]个粉丝pick了你

# 流失
    # 每周3 执行一次轮询，超过7天没有访问的用户：[1-2]个粉丝pick了你
    #
    # 每周3 执行一次轮询，超过30天没有访问的用户：[1-2]个粉丝pick了你
